'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _semver;

function _load_semver() {
  return _semver = _interopRequireDefault(require('semver'));
}

var _diagnosis;

function _load_diagnosis() {
  return _diagnosis = _interopRequireDefault(require('../diagnosis'));
}

var _npmClient;

function _load_npmClient() {
  return _npmClient = _interopRequireDefault(require('../../npm-client'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _package;

function _load_package() {
  return _package = _interopRequireDefault(require('../../../package.json'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ValidateBitVersion = function (_Diagnosis) {
  _inherits(ValidateBitVersion, _Diagnosis);

  function ValidateBitVersion() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ValidateBitVersion);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ValidateBitVersion.__proto__ || Object.getPrototypeOf(ValidateBitVersion)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'validate bit version', _this.description = 'validate that bit version is up to date', _this.category = 'core', _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ValidateBitVersion, [{
    key: '_formatSymptoms',
    value: function _formatSymptoms(bareResult) {
      if (!bareResult.data) throw new Error('ValidateBitVersion, bareResult.data is missing');
      if (!bareResult.data.latestVersion) {
        return 'could not fetch bit latest version';
      }
      return `bit is not up to date. 
    your version: ${(_constants || _load_constants()).BIT_VERSION} 
    latest version: ${bareResult.data.latestVersion}`;
    }
  }, {
    key: '_formatManualTreat',
    value: function _formatManualTreat(bareResult) {
      if (!bareResult.data) throw new Error('ValidateBitVersion, bareResult.data is missing');
      if (!bareResult.data.latestVersion) {
        return 'please make sure you have an internet connection';
      }
      return 'please upgrade your bit version';
    }
  }, {
    key: '_runExamine',
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        var bitLatestVersion, bitCurrentVersion;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (_npmClient || _load_npmClient()).default.getPackageLatestVersion((_package || _load_package()).default.name);

              case 2:
                bitLatestVersion = _context.sent;
                bitCurrentVersion = (_constants || _load_constants()).BIT_VERSION;

                if (!bitLatestVersion) {
                  _context.next = 8;
                  break;
                }

                if (!(_semver || _load_semver()).default.lt(bitCurrentVersion, bitLatestVersion)) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt('return', {
                  valid: false,
                  data: {
                    latestVersion: bitLatestVersion
                  }
                });

              case 7:
                return _context.abrupt('return', {
                  valid: true
                });

              case 8:
                return _context.abrupt('return', {
                  valid: false,
                  data: {
                    latestVersion: null
                  }
                });

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _runExamine() {
        return _ref2.apply(this, arguments);
      }

      return _runExamine;
    }()
  }]);

  return ValidateBitVersion;
}((_diagnosis || _load_diagnosis()).default);

exports.default = ValidateBitVersion;