'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = registerCoreAndExtensionsDiagnoses;

var _doctorRegistrar;

function _load_doctorRegistrar() {
  return _doctorRegistrar = _interopRequireDefault(require('./doctor-registrar'));
}

var _diagnosis;

function _load_diagnosis() {
  return _diagnosis = _interopRequireDefault(require('./diagnosis'));
}

var _validateWorkspaceBitJsonSyntax;

function _load_validateWorkspaceBitJsonSyntax() {
  return _validateWorkspaceBitJsonSyntax = _interopRequireDefault(require('./core-diagnoses/validate-workspace-bit-json-syntax'));
}

var _validateGitExec;

function _load_validateGitExec() {
  return _validateGitExec = _interopRequireDefault(require('./core-diagnoses/validate-git-exec'));
}

var _orphanSymlinkObjects;

function _load_orphanSymlinkObjects() {
  return _orphanSymlinkObjects = _interopRequireDefault(require('./core-diagnoses/orphan-symlink-objects'));
}

var _brokenSymlinkFiles;

function _load_brokenSymlinkFiles() {
  return _brokenSymlinkFiles = _interopRequireDefault(require('./core-diagnoses/broken-symlink-files'));
}

var _validateNpmExec;

function _load_validateNpmExec() {
  return _validateNpmExec = _interopRequireDefault(require('./core-diagnoses/validate-npm-exec'));
}

var _validateYarnExec;

function _load_validateYarnExec() {
  return _validateYarnExec = _interopRequireDefault(require('./core-diagnoses/validate-yarn-exec'));
}

var _validateBitVersion;

function _load_validateBitVersion() {
  return _validateBitVersion = _interopRequireDefault(require('./core-diagnoses/validate-bit-version'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function registerCoreAndExtensionsDiagnoses() {
  var extensionDiagnoses = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var diagnoses = [new (_validateWorkspaceBitJsonSyntax || _load_validateWorkspaceBitJsonSyntax()).default(), new (_validateGitExec || _load_validateGitExec()).default(), new (_orphanSymlinkObjects || _load_orphanSymlinkObjects()).default(), new (_brokenSymlinkFiles || _load_brokenSymlinkFiles()).default(), new (_validateNpmExec || _load_validateNpmExec()).default(), new (_validateYarnExec || _load_validateYarnExec()).default(), new (_validateBitVersion || _load_validateBitVersion()).default()].concat(extensionDiagnoses);
  (_doctorRegistrar || _load_doctorRegistrar()).default.init(diagnoses);
}